﻿Public Class filework
    Const VB_FDR As String = "vb"
    Const PROJECT_NAME As String = "projectname.txt"
    Const READ_M As String = "Readm.txt"
    Shared artxt As New List(Of String)
    Shared arst As New List(Of String)
    Shared arpas As New List(Of String)
    ' 項目の保存
    Public Sub filesav(ByVal ParamArray st1() As String)
        Dim txt As String
        Dim arst As String = ""
        For Each txt In st1
            arst &= """,""" & txt
        Next

        '先頭から3文字を削除する。
        Dim savest As String
        savest = arst.Remove(0, 2)  '先頭の",を削除する。

        'ファイル名をst1(0)にする。
        Dim writer As New IO.StreamWriter(Application.StartupPath & "\" & VB_FDR & "\" & st1(0) & ".csv", True, System.Text.Encoding.GetEncoding("shift-jis"))
        writer.WriteLine(savest & """")
        writer.Close()

        Dim f4 As New Form4
        f4.Show()
    End Sub
    'テキストチェインジによる検索開始
    Public Sub txtchange(ByVal txt As String)
        Dim f1 As New Form1
        Dim ofolder As New IO.DirectoryInfo(Application.StartupPath & "\" & VB_FDR)
        Dim ofile As IO.FileInfo

        Try
            For Each ofile In ofolder.GetFiles(txt & "*.csv", IO.SearchOption.AllDirectories)
                txtread(ofile.FullName)
            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub
    'テキストチェインジによる検索ファイルの読み取り。ファイルの一行ごとにForm1に渡す。メソッドの定義
    'ボタンクリックで検索する場合のファイルの読み込み
    '共通で使用する。
    Private Sub txtread(ByVal ofilname As String)   'ofilnameはファイルのフルパス
        Dim f1 As New Form1
        Dim reader As New IO.StreamReader(ofilname, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim line As String

        line = reader.ReadLine
        Do Until IsNothing(line)
            f1.readchan(line)
            line = reader.ReadLine
        Loop
        reader.Close()

    End Sub
    'ボタンクリックで検索する場合  語句で検索  CheckBox1.Checked = True
    Public Sub ccb1(ByVal st1 As String)  'st1はTextBox1に入力された値
        Dim f1 As New Form1
        Dim ofolder As New IO.DirectoryInfo(Application.StartupPath & "\" & VB_FDR)
        Dim ofile As IO.FileInfo
        Dim filename As String  'ofile.FullNameから拡張子を除いたファイル名
        Dim ufilename As String 'ufilenameを大文字化する
        Dim ust1 As String      'st1を大文字化する
        ust1 = UCase(st1)
        For Each ofile In ofolder.GetFiles("*" & "*.csv", IO.SearchOption.AllDirectories)
            filename = IO.Path.GetFileNameWithoutExtension(ofile.FullName)
            ufilename = UCase(filename)
            If ufilename.IndexOf(ust1) >= 0 Then
                txtread(ofile.FullName)  'メソッド
            End If
        Next
    End Sub

    'ボタンクリックで検索する場合  語句,コメントで検索  CheckBox2.Checked = True
    Public Sub ccb2(ByVal st As String)   'stは検索文字
        Dim ofile As String   '検索文字が含まれているファイルのフルパス

        For Each ofile In My.Computer.FileSystem.FindInFiles(Application.StartupPath & "\" & VB_FDR, st, False, FileIO.SearchOption.SearchAllSubDirectories)
            ccb2read(ofile, st)  'メソッド
        Next
    End Sub
    'ボタンクリックで検索する場合  語句,コメントで検索  メソッド
    Private Sub ccb2read(ByVal ofile As String, ByVal st As String)   'ofileはファイルのフルパス
        Dim f1 As New Form1
        Dim reader As New IO.StreamReader(ofile, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim line As String
        Dim item() As String     'ファイルの各項目
        Dim st1 As String        '語句
        Dim st5 As String        'コメント
        Dim ust As String        '検索文字を大文字化
        Dim ust1 As String       '語句を大文字化
        Dim ust5 As String       'コメントの大文字化


        line = reader.ReadLine
        Do Until IsNothing(line)
            item = line.Split(""", """)
            st1 = item(1)
            st5 = item(5)

            st1 = st1.Replace("""", "")
            st5 = st5.Replace("""", "")

            ust = UCase(st)
            ust1 = UCase(st1)
            ust5 = UCase(st5)

            If ust1.IndexOf(ust) >= 0 OrElse ust5.IndexOf(st) >= 0 Then
                f1.readchan(line)
            End If
            line = reader.ReadLine
        Loop
        reader.Close()
    End Sub

    'Form2にコメントを表示
    Public Sub fshow(ByVal coment As String)
        artxt.Add(coment)                  'リストにコメントをAddしておく

        Dim f2 As New Form2
        f2.TextBox1.Text = coment
        f2.Show()
        f2.TextBox1.DeselectAll()
    End Sub
    'URLからＷebに接続
    Public Sub fweb(ByVal sturl As String)
        Dim f3 As New Form3

    End Sub
    'コメントの上書き
    Public Sub overwrite(ByVal st As String)  'stはForm2で上書きしたときの値
        arst.Add(st)         'リストにコメントをAddしておく

        Dim ofolder As New IO.DirectoryInfo(Application.StartupPath & "\" & VB_FDR)
        Dim ofile As IO.FileInfo

        For Each ofile In ofolder.GetFiles("*.txt", IO.SearchOption.AllDirectories)
            stread(ofile.FullName)   'メソッド
        Next

    End Sub
    Private Sub stread(ByVal fulpas As String)  'fulpas
        Dim reader As New IO.StreamReader(fulpas, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim line As String
        Dim item() As String     'ファイルの各項目
        Dim st1 As String        '語句
        Dim st3 As String        '章節
        Dim st5 As String        'コメント
        Dim st7 As String        'URL

        line = reader.ReadLine
        Try

            Do Until IsNothing(line)
                item = line.Split(""", """)
                st1 = item(1)
                st3 = item(3)
                st5 = item(5)
                st7 = item(7)

                st1 = st1.Replace("""", "")
                st3 = st3.Replace("""", "")
                st5 = st5.Replace("""", "")
                st7 = st7.Replace("""", "")

                If st5 = artxt(0) Then
                    reader.Close()
                    Dim writer As New IO.StreamWriter(fulpas, False, System.Text.Encoding.GetEncoding("shift-jis"))
                    writer.WriteLine("""" & st1 & """,""" & st3 & """,""" & arst(0) & """,""" & st7 & """")
                    writer.Close()

                    artxt.Clear()  'リストをクリアーする
                    arst.Clear()   'リストをクリアーする

                    Exit Do
                End If

                line = reader.ReadLine
            Loop
            reader.Close()
        Catch ex As Exception
            '何もしない
        End Try

    End Sub
    'プロジェクト名から検索
    Public Sub projeect(ByVal st As String)
        Dim f1 As New Form1
        Dim ofolder As New IO.DirectoryInfo(arpas(0))
        Dim ofile As IO.FileInfo
        Dim filename As String  '拡張子を除いたファイル名
        Dim ust As String    'stの大文字化
        Dim uofile As String 'ofileの大文字化      
        ust = UCase(st)
        Try

            For Each ofile In ofolder.GetFiles("*.sln", IO.SearchOption.AllDirectories)
                filename = IO.Path.GetFileNameWithoutExtension(ofile.ToString)
                uofile = UCase(filename)
                If uofile.IndexOf(ust) >= 0 Then
                    f1.readchan(ofile.Name)
                End If
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    'プロジェクト名のパスを保存
    Public Sub writepas(ByVal pas As String)
        arpas.Clear()   'arpasをクリアーする 
        Dim writer As New IO.StreamWriter(Application.StartupPath & "\" & PROJECT_NAME, False)
        writer.WriteLine(pas)
        writer.Close()
    End Sub

    Public _pas As String
    'Form1のTextBox2に表示するパス名
    Public ReadOnly Property pas() As String
        Get
            arpas.Clear()
            Dim reader As New IO.StreamReader(Application.StartupPath & "\" & PROJECT_NAME)
            Dim _pas As String
            _pas = reader.ReadLine
            reader.Close()
            arpas.Add(_pas)
            Return _pas    'Form1のTextBox2に表示するパス名
        End Get
    End Property
    'ListView1でダブルクリックで取得した値を起動
    Public Sub vbstart(ByVal lstname As String)  'lstname　　ListView1でダブルクリックで取得した値
        Dim ofolder As New IO.DirectoryInfo(arpas(0))
        Dim ofile As IO.FileInfo
        Dim filename As String
        Try
            For Each ofile In ofolder.GetFiles("*.sln", IO.SearchOption.AllDirectories)
                filename = ofile.Name
                If filename = lstname Then
                    Process.Start(ofile.FullName)
                End If
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    '項目の削除
    Public Sub clrlst(ByVal item As String)
        IO.File.Delete(Application.StartupPath & "\" & VB_FDR & "\" & item & ".csv")
    End Sub
    '説明書の表示
    Public Sub readm()
        Dim f5 As New Form5
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & READ_M, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim readtxt As String
        readtxt = reader.ReadToEnd
        f5.TextBox1.Text = readtxt
        f5.Show()
        f5.TextBox1.DeselectAll()
    End Sub
    'お気に入りの検索
    Public Sub favarit()
        Dim f6 As New Form6
        'お気に入りのパスを取得
        Dim favaritst As String   'お気に入りのフォルダーパス
        favaritst = Environment.GetFolderPath(Environment.SpecialFolder.Favorites)

        Dim favpas As String
        Dim favname As String

        Dim ofolder As New IO.DirectoryInfo(favaritst)
        Dim ofile As IO.FileInfo

        For Each ofile In ofolder.GetFiles("*.url", IO.SearchOption.AllDirectories)
            favpas = ofile.FullName
            favname = IO.Path.GetFileNameWithoutExtension(ofile.FullName)
            f6.favpas(favpas, favname)
        Next
    End Sub
    'ListBoxで選択されたパスからWebをスタート
    Public Sub doproc(ByVal pas As String)
        Process.Start(pas)
    End Sub
    'お気に入りの削除
    Public Sub deletfav(ByVal favst As String)
        IO.File.Delete(favst)
    End Sub
End Class
